#ifdef	HI_TECH_C
#include	<htc.h>
#else
#include <c8051f120.h>
#endif


long timeval;
short	tick;

// timer 3 interrupt
void
timerint() interrupt 14
{
	TF3 = 0;
	timeval++;
	tick++;
	if(tick == 500)
		P1 |= 0x40;
	else if(tick == 1000) {
		P1 &= ~0x40;
		tick = 0;
	}
}

long time (long *t)
{
	long tval;

	EA   = 0;
	tval = timeval;
	EA = 1;
	return tval;
}

void
putch(char c)  
{
	SFRPAGE = UART0_PAGE;
	if (c == '\n')                      // If carriage return
	{
		while (!TI0);
		TI0 = 0;
		SBUF0 = 0x0d;                    // Output CR 
	}

	while (!TI0);                       // Wait for transmit complete
	TI0 = 0;

	SBUF0 = c;                          // Send character
}
char
putchar(char c)  
{
	SFRPAGE = UART0_PAGE;
	if (c == '\n')                      // If carriage return
	{
		while (!TI0);
		TI0 = 0;
		SBUF0 = 0x0d;                    // Output CR 
	}

	while (!TI0);                       // Wait for transmit complete
	TI0 = 0;

	SBUF0 = c;                          // Send character
	return c;
}
